<?php
class AthleteGateway {
    private $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function getAthlete() {
        $query = "SELECT * FROM Athlete";
        return $this->connection->executeWithErrorHandling($query);
    }

    public function getAthleteById($userId) {
        $query = "SELECT * FROM Athlete WHERE idAthlete = :id";
        $params = [':id' => [$userId, PDO::PARAM_INT]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getAthleteByName($name) {
        $query = "SELECT * FROM Athlete WHERE nom = :name";
        $params = [':name' => [$name, PDO::PARAM_STR]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getAthleteByFirstName($firstName) {
        $query = "SELECT * FROM Athlete WHERE prenom = :firstName";
        $params = [':firstName' => [$firstName, PDO::PARAM_STR]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getAthleteByEmail($email) {
        $query = "SELECT * FROM Athlete WHERE email = :email";
        $params = [':email' => [$email, PDO::PARAM_STR]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getAthleteByGender($gender) {
        $query = "SELECT * FROM Athlete WHERE sexe = :gender";
        $params = [':gender' => [$gender, PDO::PARAM_STR]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getAthleteByHeight($height) {
        $query = "SELECT * FROM Athlete WHERE taille = :height";
        $params = [':height' => [$height, PDO::PARAM_INT]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getAthleteByWeight($weight) {
        $query = "SELECT * FROM Athlete WHERE poids = :weight";
        $params = [':weight' => [$weight, PDO::PARAM_INT]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getAthleteByBirthDate($birthdate) {
        $query = "SELECT * FROM Athlete WHERE dateNaissance = :birthdate";
        $params = [':birthdate' => [$birthdate, PDO::PARAM_STR]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }
}


// Exemple d'utilisation
//$dsn = "pgsql:host=localhost;port=5432;dbname=mydatabase;user=myuser;password=mypassword";
//$connection = new Connection($dsn);
//$gateway = new UserGateway($connection);

//$allAth = $gateway->getAthlete();
//print_r($allAth);

//$singleAth = $gateway->getAthleteById(1);
//print_r($singleAth);

?>
