<?php
class CoachGateway {
    private $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function getCoach() {
        $query = "SELECT * FROM Coach";
        return $this->connection->executeWithErrorHandling($query);
    }

    public function getCoachById($userId) {
        $query = "SELECT * FROM Coach WHERE idCoach = :id";
        $params = [':id' => [$userId, PDO::PARAM_INT]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getCoachByName($name) {
        $query = "SELECT * FROM Coach WHERE nom = :name";
        $params = [':name' => [$name, PDO::PARAM_STR]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getCoachByFirstName($firstName) {
        $query = "SELECT * FROM Coach WHERE prenom = :firstName";
        $params = [':firstName' => [$firstName, PDO::PARAM_STR]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getCoachByEmail($email) {
        $query = "SELECT * FROM Coach WHERE email = :email";
        $params = [':email' => [$email, PDO::PARAM_STR]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getCoachByGender($gender) {
        $query = "SELECT * FROM Coach WHERE sexe = :gender";
        $params = [':gender' => [$gender, PDO::PARAM_STR]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getCoachByHeight($height) {
        $query = "SELECT * FROM Coach WHERE taille = :height";
        $params = [':height' => [$height, PDO::PARAM_INT]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getAthleteByBirthDate($birthdate) {
        $query = "SELECT * FROM Coach WHERE dateNaissance = :birthdate";
        $params = [':birthdate' => [$birthdate, PDO::PARAM_STR]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }
}